Unit MathTmt;

Interface
Type fixed=longint;

Function mLongToFixed(long:longint):fixed;
Function mRealToFixed(r:real):fixed;
Function mFixedMul(fix1,fix2:fixed):fixed;
Function mFixedMulLongToLong(fix:fixed;long:longint):longint;
Function mFixedDiv(fix1,fix2:fixed):fixed;
Function mFixedDivLongToFix(fix:fixed;long:longint):fixed;
Function mRound(fix:fixed):longint;
Function mFixedRound(fix:fixed):fixed;
Function mTrunc(fix:fixed):longint;

Implementation
Function mLongToFixed(long:longint):fixed;
begin
   mLongToFixed:=long*65536;
end;
Function mRealToFixed(r:real):fixed;
begin
   mRealToFixed:=round(r*65536);
end;
Function mFixedMul(fix1,fix2:fixed):fixed;assembler;
asm
   mov eax,fix1
   mov edx,fix2
   imul edx
   shrd eax,edx,16
   mov edx,eax
--   sar edx,16
end;
Function mFixedMulLongToLong(fix:fixed;long:longint):longint;assembler;
asm
   mov eax,fix
   mov ecx,long
   imul ecx
   shrd eax,edx,16
   adc eax,0
end;

Function mFixedDiv(fix1,fix2:fixed):fixed;assembler;
asm
   mov edx,fix1
   shrd eax,edx,16
   sar edx,16
   mov ecx,fix2
   idiv ecx
end;
Function mFixedDivLongToFix(fix:fixed;long:longint):fixed;assembler;
asm
   mov eax,fix
   cdq
   mov ecx,long
   idiv ecx
end;
Function mRound(fix:fixed):longint;assembler;
asm
   mov eax,fix
   sar eax,16
   adc eax,0
end;
Function mFixedRound(fix:fixed):fixed;assembler;
asm
   mov eax,fix
   add eax,$8000
   and eax,$0FFFF0000
end;
Function mTrunc(fix:fixed):longint;assembler;
asm
   mov eax,fix
   sar eax,16
end;
End.