Procedure DrawFlatPoly8(poly:TPolygonPtr; Num:byte; color:word; Where:TPageType);
{ poly - pointer to polygon structure }
{ Polygon structure must have format polygon: array[1..n] of TVertex3dFix }
{ Num  - number of vertexes in poly}
{ Color - filling color for flat polygons }
var n:integer;
    MinVrtx,MaxVrtx:integer;
    LeftVrtx,RightVrtx:integer;
    LeftStepX,RightStepX,CurrLeftX,CurrRightX:fixed;

    CurrY:fixed;
    LeftSectionSize,RightSectionSize:longint;
    MinY,MaxY:fixed;
    offs:dword;

{$I src\include\flatscan.pas}

var hsize:longint;
    temp,x:fixed;
Begin
   asm
 --  MinY:= 2140000000;
       mov edi,2140000000
 --  MaxY:=-2140000000;
       mov ebx,-2140000000

       mov ecx,1
       mov esi,Poly

{ scan for max&min vertexes}
--   for n:=1 to Num do begin
   @@ScanVertex:
--      temp:=Poly^[n].y;
       mov edx,[esi][4]
--      if temp<MinY then begin
       cmp edx,edi
       jge @@Above
--         MinY:=temp;
         mov edi,edx
--         MinVrtx:=n
         mov al,cl
--      end;
      @@Above:
--      if temp>MaxY then begin
       cmp edx,ebx
       jle @@Bellow
--         MaxY:=temp;
         mov ebx,edx
--         MaxVrtx:=n
         mov ah,cl
--      end;
      @@Bellow:
       inc ecx
       add esi,TYPE(TVertex3dFix)
       cmp cl,num
       jng @@ScanVertex
--   end;

--   LeftVrtx:=MinVrtx;  {left side starting vertex}
--   RightVrtx:=MinVrtx;
     mov byte ptr LeftVrtx,al
     mov byte ptr RightVrtx,al
     mov byte ptr MaxVrtx,ah

--   CurrY:=mRound(MinY);
     mov eax,edi
     sar eax,16
     adc eax,0

--   offs:=CurrY*Where.SizeX;
     movzx edx,Where.SizeX
     mov ecx,Where.seg
     mul edx
     add eax,ecx
     mov offs,eax


--   while LeftSectionSize<=0 do begin
@@WaitForLeftSection1:
--   if LeftVrtx=MaxVrtx then exit;
       mov ax,MaxVrtx
       cmp ax,LeftVrtx
       jne @@ScanLeft
          jmp @@escape
  @@ScanLeft:

   {search for first usable left & right sections}
--     LeftSection
       call LeftSection
       cmp LeftSectionSize,0
       jle @@WaitForLeftSection1
--   end;

--   while RightSectionSize<=0 do begin
@@WaitForRightSection1:
--   if RightVrtx=MaxVrtx then exit;
       mov ax,MaxVrtx
       cmp ax,RightVrtx
       jne @@ScanRight
          jmp @@escape
  @@ScanRight:

--     RightSection
       call RightSection
       cmp RightSectionSize,0
       jle @@WaitForRightSection1
--   end;


@@MainLoop:
     -- x:=mRound(CurrLeftX);
     -- hsize:=mRound(CurrRightX)-x;
     mov edx,CurrLeftX
     mov ebx,CurrRightX
     mov ecx,edx
     shr edx,16
     mov eax,ebx
     adc edx,0
     shr eax,16
--     mov x,edx
     adc eax,0

     sub eax,edx
  jle @@ZeroWidth        -- if hSize>0 then begin

{************ INNER LOOP BEGINS HERE **********************}
        {calculate offset of first point}
        mov ecx,eax        -- eax=hsize
        mov edi,offs

        mov al,byte ptr color
        add edi,edx  -- edi=edi+x

        mov ah,al
        mov bx,ax
        shl eax,16
        mov ax,bx

{$IFDEF ALIGN_SCAN}
        {fill horizontal line}
        mov edx,edi
        mov bl,0 {clear flag}
        shr edx,1      {is address word aligned?}
        jnc @@NonOddAddress     {yes, go and fill from non-odd address}
        {Suxx!! address is odd!}
        stosb              {now address is non-odd}
        dec ecx      {substract this putted byte from counter}
        jz @@done2 {if there was only one byte, exit from here}

@@NonOddAddress:
{put words & dwords first, and only then put byte}
        shr ecx,1        {is some bytes here?}
        jnc @@FillWithWord2  {ok, no bytes left here}
        {O-Ow, one byte here}
        {save flag, so we must put it at the and}
        mov bl,1
@@FillWithWord2:
        jcxz @@done
        {is some words here?}
        shr ecx,1
        jnc @@FillWithDWord2 {no, put only dwords}
        {put this sucked word}
        stosw
        inc edx  {because we put word here, we must update address}
        jcxz @@done

@@FillWithDWord2:
        {check address for dwords}
        shr edx,1
        jnc @@CoolForDwords  {cool, dwords begin at non-odd address!!}
        {it's non-dword aligned address}
        stosw
        dec ecx
        jz @@skip1
        rep stosd
@@skip1:
        stosw
        {ok, we fineshed on this}
        jmp @@Done   {go out from here}

@@CoolForDWords:
        {wow, put all dwords here!}
        rep stosd

@@done:
        cmp bl,1  {we must put our first byte?}
        jne @@done2 {no, go out from here}
        stosb {put it here}
@@done2:
{$ELSE}
        shr ecx,1
        jnc @@1
        stosb
@@1:
        shr ecx,1
        jnc @@2
        stosw
@@2:    rep stosd
{$ENDIF}
{************ INNER LOOP ENDS HERE **********************}
  @@ZeroWidth:
     --offs+:=Where.SizeX;
     mov eax,offs
     movzx edx,Where.SizeX
     add eax,edx
     mov offs,eax

     --LeftSectionSize-:=1;
     --RightSectionSize-:=1;
     mov eax,RightSectionSize
     mov edx,LeftSectionSize
     dec eax
     dec edx
     mov RightSectionSize,eax
     mov LeftSectionSize,edx

     --if LeftSectionSize<=0 then
     cmp edx,0
     jg @@LeftSectionOK
       -- while LeftSectionSize<=0 do begin
   @@WaitForLeftSection:
            --if LeftVrtx=MaxVrtx then exit;
         mov ax,LeftVrtx
         cmp ax,MaxVrtx
         jne @@GoAhead1
           --ret
           jmp @@escape
     @@GoAhead1:
         --LeftSection
         call LeftSection
         cmp LeftSectionSize,0
         jle @@WaitForLeftSection
         jmp @@ScanRightSection
       -- end
     -- else begin
   @@LeftSectionOK:
      --CurrLeftX+:=LeftStepX;
      mov eax,CurrLeftX
      mov edx,LeftStepX
      add eax,edx
      mov CurrLeftX,eax
   --end;
@@ScanRightSection:
     cmp RightSectionSize,0
     jg @@RightSectionOK
       -- while RightSectionSize<=0 do begin
   @@WaitForRightSection:
            --if RightVrtx=MaxVrtx then exit;
         mov ax,RightVrtx
         cmp ax,MaxVrtx
         jne @@GoAhead2
           --ret
           jmp @@escape
     @@GoAhead2:
         --RightSection
         call RightSection
         cmp RightSectionSize,0
         jle @@WaitForRightSection
         --jmp @@ScanRightSection
         jmp @@MainLoop
       -- end
     -- else begin
   @@RightSectionOK:
      --CurrRightX+:=RightStepX;
      mov eax,CurrRightX
      mov edx,RightStepX
      --CurrRightTextX+:=RightTextStepX;
      add eax,edx
      mov CurrRightX,eax
   --end;

--until false;
   jmp @@MainLoop
@@escape:
  end;
end;



Procedure DrawTransparentFlatPoly8(poly:TPolygonPtr; Num:byte; color:word; Where:TPageType);
{ poly - pointer to polygon structure }
{ Polygon structure must have format polygon: array[1..n] of TVertex3dFix }
{ Num  - number of vertexes in poly}
{ Color - filling color for flat polygons }
{ !!NOTE!! For correct result transparency table must be loaded first, using}
{  LoadTransparencyTable();                          }
var n:integer;
    MinVrtx,MaxVrtx:integer;
    LeftVrtx,RightVrtx:integer;
    LeftStepX,RightStepX,CurrLeftX,CurrRightX:fixed;

    CurrY:fixed;
    LeftSectionSize,RightSectionSize:longint;
    MinY,MaxY:fixed;
    offs:dword;

{$I src\include\flatscan.pas}

var hsize:longint;
    temp,x:fixed;
Begin
   MinY:= 2140000000;
   MaxY:=-2140000000;
{ scan for max&min vertexes}
   for n:=1 to Num do begin
      temp:=Poly^[n].y;
      if temp<MinY then begin
         MinY:=temp;
         MinVrtx:=n
      end;
      if temp>MaxY then begin
         MaxY:=temp;
         MaxVrtx:=n
      end;
   end;
   LeftVrtx:=MinVrtx;  {left side starting vertex}
   RightVrtx:=MinVrtx;

   CurrY:=mRound(MinY);

   RightSectionSize:=0;
   LeftSectionSize:=0;
   {search for first usable left & right sections}
   while RightSectionSize<=0 do begin
     if RightVrtx=MaxVrtx then exit;
     RightSection
   end;
   while LeftSectionSize<=0 do begin
     if LeftVrtx=MaxVrtx then exit;
     LeftSection
   end;

   offs:=CurrY*Where.SizeX;
repeat
   {get rounded size of horizontal line}
   x:=mRound(CurrLeftX);
   hsize:=mRound(CurrRightX)-x;
   if hsize>0 then begin
      asm
        cld

        {calculate offset of first point}
        mov edi,dword ptr Where
        mov ecx,hsize
        add edi,offs
        xor ebx,ebx
        add edi,x

        mov esi,PTranspTable   { load pointer to transparancy table }
        mov al,byte ptr color

{$IFDEF ALIGN_SCAN}
        {fill horizontal line}
        mov edx,edi
        mov bl,al
        mov dh,0 {clear flag}
        shr dl,1      {is address word aligned?}
        jnc @@NonOddAddress     {yes, go and fill from non-odd address}
        {Suxx!! address is odd!}
        mov bh,[edi]      {get color from background}
        dec ecx      {substract putted byte from counter}
        {AUGHT! AGI's here :( }
        mov al,[esi+ebx]  {get new transparent color}
        stosb             {put it and increase destination pointer}
        {now address is non-odd}
        jcxz @@done2 {if there was only one byte, exit from here}
@@NonOddAddress:
{put words & dwords first, and only then put byte}
        shr ecx,1        {is some bytes here?}
        jnc @@FillWithWord2  {ok, no bytes left here}
        {O-Ow, one byte here}
        {save flag, so we must put it at the and}
        mov dh,1
        jcxz @@done

@@FillWithWord2:
        {is some words here?}
        shr ecx,1
        jnc @@FillWithDWord2 {no, put only dwords}
        {put this word}
 {this is very crappy code with many AGI's, and i don't know how optimize it}
        mov ax,[edi]     {calculate 2 transp colors and put them together}
        mov bh,al
        mov al,[esi+ebx]
        mov bh,ah
        inc edx  {because we put word here, we must update address}
        mov ah,[esi+ebx]
        stosw
        jcxz @@done

@@FillWithDWord2:
        {check address for dwords}
        shr dl,1
        jnc @@CoolForDwords  {cool, dwords begin at non-odd address!!}
        {non-dword aligned address}
        {put word first}
        mov ax,[edi]
        mov bh,al
        dec ecx
        mov al,[esi+ebx]
        mov bh,ah
        mov ah,[esi+ebx]
        stosw
        jcxz @@skip1
    @@looper:
        mov eax,[edi]
        mov bh,al
        mov al,[esi+ebx]
        mov bh,ah
        mov ah,[esi+ebx]
        ror eax,16
        mov bh,al
        mov al,[esi+ebx]
        mov bh,ah
        mov ah,[esi+ebx]
        ror eax,16  {swap hi and lo words}
        stosd
        dec ecx
        jnz @@looper
    @@skip1:
        mov ax,[edi]
        mov bh,al
        mov al,[esi+ebx]
        mov bh,ah
        mov ah,[esi+ebx]
        stosw

        {ok, we fineshed on this}
        jmp @@Done   {go out from here}

@@CoolForDWords:
        {wow, put all dwords here!}
    @@looper2:
        mov eax,[edi]
        mov bh,al
        mov al,[esi+ebx]
        mov bh,ah
        mov ah,[esi+ebx]
        ror eax,16
        mov bh,al
        mov al,[esi+ebx]
        mov bh,ah
        mov ah,[esi+ebx]
        ror eax,16  {swap hi and lo words}
        stosd
        dec ecx
        jnz @@looper2

@@done:
        cmp dh,1  {we must put our first byte?}
        jne @@done2 {no, go out from here}
        stosb {put it here}
@@done2:
{$ELSE}
        mov bl,al
        shr ecx,1
        jnc @@1
        mov bh,[edi]
        mov al,[esi+ebx]
        stosb
        jcxz @@done
@@1:
        shr ecx,1
        jnc @@2
        mov ax,[edi]
        mov bh,al
        mov al,[esi+ebx]
        mov bh,ah
        mov ah,[esi+ebx]
        stosw
        jcxz @@done
@@2:
        mov eax,[edi]
        mov bh,al
        mov al,[esi+ebx]
        mov bh,ah
        mov ah,[esi+ebx]
        ror eax,16
        mov bh,al
        mov al,[esi+ebx]
        mov bh,ah
        mov ah,[esi+ebx]
        ror eax,16  {swap hi and lo words}
        stosd
        dec ecx
        jnz @@2
@@done:
{$ENDIF}
      end;
   end;
   offs+:=Where.SizeX;
--   LeftSectionSize:=LeftSectionSize-1;
--   RightSectionSize:=RightSectionSize-1;
   LeftSectionSize-:=1;
   RightSectionSize-:=1;

   if LeftSectionSize<=0 then
      while LeftSectionSize<=0 do begin
         if LeftVrtx=MaxVrtx then exit;
         LeftSection
      end
   else
--      CurrLeftX:=CurrLeftX+LeftStepX;
        CurrLeftX+:=LeftStepX;

   if RightSectionSize<=0 then
      while RightSectionSize<=0 do begin
        if RightVrtx=MaxVrtx then exit;
        RightSection
      end
   else
--      CurrRightX:=CurrRightX+RightStepX;
        CurrRightX+:=RightStepX;

until false;
end;
